<template>
  <div>
    <FullCalendar :options="calendarOptions" />
    <modal ref="modalName">
      <template v-slot:header>
        <h1>Rendez-vous</h1>
      </template>

      <template v-slot:body>
        {{ title }}
      </template>

      <template v-slot:footer>
        <div>
          <button @click="$refs.modalName.closeModal()" class="btn btn-success">OK</button>
        </div>
      </template>
    </modal>
  </div>

</template>

<script>
import FullCalendar from '@fullcalendar/vue'
import dayGridPlugin from '@fullcalendar/daygrid'
import interactionPlugin from '@fullcalendar/interaction'
import frLocale from '@fullcalendar/core/locales/fr'
import axios from "axios";
import Modal from "./Modal"

export default {
  name: "Calendar",
  components: {
    FullCalendar,
    Modal
  },
  props: {
    url: {
      type: String,
      default: ''
    },
  },
  data() {
    return {
      calendarOptions: {
        plugins: [ dayGridPlugin, interactionPlugin ],
        locale: frLocale,
        initialView: 'dayGridMonth',
        eventClick: this.handleEventClick,
        events: []
      },
      title: ''
    }
  },
  mounted() {
    this.loadItems()
  },
  methods: {
    loadItems(event){
      axios.get(this.url).then(response => {
        this.calendarOptions.events = response.data
      })
    },
    handleEventClick(clickInfo) {
      this.title = clickInfo.event.title+" prévu le "+clickInfo.event.start.toLocaleString('fr-FR');
      this.$refs.modalName.openModal()
    }
  }
}
</script>

<style scoped>
.overflow-hidden {
  overflow: hidden;
}
.modal {
  display: block;
  z-index: 99999;
}
</style>